//Para compilar******************************
//g++ disp4.cpp clientSocketHttp6.cpp -lbcm2835 -o Disp4
//******************************************

#include <stdio.h>
#include <stdlib.h>
#include <sstream>
#include <unistd.h>
#include <string.h>
#include <string>
#include <vector>                           
#include <fcntl.h>                              
#include <sys/types.h>
#include <sys/stat.h>
#include <iostream>
#include <fstream>
#include <errno.h>
#include <sys/ioctl.h> 
#include <sys/socket.h>
#include <net/if.h>
#include <stdio.h>
#include <time.h>
#include <bcm2835.h>
#include <stdio.h>

#include "clientSocketHttp6.h"
#include "RPi_SHT1x.h"

#define BCM2835_CORE_CLK_HZ 250000000
#define PIN_TRIG RPI_GPIO_P1_11
#define PIN_ECHO RPI_GPIO_P1_16
#define GREEN_LED RPI_GPIO_P1_24
#define RED_LED RPI_GPIO_P1_18
#define MAX_SML_BUFF 10000

std::string updateContext(float,float,int,int);
std::string queryContext();
void updateLed(int);
float getTemp(void);
float getHumid(void);

int main (void) {
    std::stringstream strings;
	std::string sendData;
	std::string replyData;
	std::string resourceDirQuery;
	std::string resourceDirUpdate;
    bcm2835_init();
	int occupied;
	int reserved;
	float reading[3]={};
	float average;
	float temp,humid;
	int m1,m2;
	resourceDirQuery = "/ngsi10/queryContext";
	resourceDirUpdate="/ngsi10/updateContext";
	 
	value humi_val,temp_val;
	
	bcm2835_gpio_fsel(PIN_TRIG, BCM2835_GPIO_FSEL_OUTP);
	bcm2835_gpio_fsel(PIN_ECHO, BCM2835_GPIO_FSEL_INPT);
	bcm2835_gpio_fsel(GREEN_LED, BCM2835_GPIO_FSEL_OUTP);
	bcm2835_gpio_fsel(RED_LED, BCM2835_GPIO_FSEL_OUTP);
	
	while(1){

	do{
		//Cheking if the lot is reserved
		printf("Cheking if the lot is reserved...\n");
		//query to entity to obtain reserved value
		sendData=queryContext();
		//printf("Query:\n %s \n",sendData.c_str());
		replyData =sendHttpSocket("130.206.83.2",1026,"POST",resourceDirQuery,std::string("application/xml"),sendData);
		//printf("Fi-Ware reply:\n %s \n",replyData.c_str());
		int pos1 = replyData.find("contextValue");
		pos1 =pos1 + 13;
		int pos2 =replyData.find("</contextValue");
		int size = pos2-pos1;
		strings<<replyData.substr(pos1,size);
		strings>>reserved;
		//printf("Reserved: %i \n", reserved);
		
		if(reserved>0){
			updateLed(reserved);
		printf("Lot reserved\n");
		}else{
		printf("Lot not reserved\n");
		}
		updateLed(reserved);
		//Updating Fi-Ware info
		//temperature, humidity, occupied, reserved
		printf("Updating FI-WARE info...\n");
		//Geting temp and humid
		temp=getTemp();
		humid=getHumid();
		//Updating context value
		sendData=updateContext(temp,humid,occupied,reserved);
		printf("Update:\n %s \n",sendData.c_str());
		replyData =sendHttpSocket("130.206.83.2",1026,"POST",resourceDirUpdate,std::string("application/xml"),sendData);
		printf("Fi-Ware reply:\n %s \n",replyData.c_str());
		
		delay(10000);
	}while(reserved>0);
	
	//If lot is not reserved...
	//Getting HC-SR04 distance to obtani occupied value
	//To obtain better accuracy it makes 3 measures and 
	//then distance will be de average of them.
	for(int i=0;i<3;i++){
		//Trigger, following datasheet it has to be a 10us pulse
        bcm2835_gpio_write(PIN_TRIG, HIGH);
		delay(0.01);
        bcm2835_gpio_write(PIN_TRIG, LOW);
		// To get the distance we use two counters
		m1=0;
		m2=0;
		//Just after trigger, waiting to Echo output starts
		while(!bcm2835_gpio_lev(PIN_ECHO)){
			bcm2835_delayMicroseconds(50);
			m1++;
		}
		// Once Echo begin with an High level signal
		// m2 must begin from m1 value
			m2=m1;
		// Getting time of Echo high level signal
		while(bcm2835_gpio_lev(PIN_ECHO)){
			bcm2835_delayMicroseconds(50);
			m2++;
		}
		// m1*delay is the time until starts Echo's signal
		// and m2*delay time to end the signal
		// (m1-m2)*delay = time of going/come back signal
		// time * sound_velocity /2 =distance (2 is because of ultrasound makes the same way twice)
		reading[i] =(m2-m1)*0.00005*340/2;
		// Delay between measures
		delay(500);
	}
	average=(reading[0]+reading[1]+reading[2])/3;
	printf("Distancia: (%f + %f + %f)/3 --> %f metros\n",reading[0],reading[1],reading[2],average );
	
	if(average<0.5){
		printf("occupied lot\n");
		occupied=1;
	}else{
		printf("Free lot\n");
		occupied=0;
	}
	updateLed(occupied);
	delay(2000);
        }
	bcm2835_close();
	return 0;
} 


//******************************************** FUNCTIONS *************************************

// Test data from file

  std::string updateContext(float val1,float val2,int val3,int val4){
  std::stringstream ss;
  std::string XML;

  ss << "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n\
  <updateContextRequest>\n\
  <contextElementList>\n\
  <contextElement>\n\
  <entityId type=\"UPCT:PARKING\" isPattern=\"false\">\n\
  <id>UPCT:PARKING:D2</id>\n\
  </entityId>\n\
  <contextAttributeList>\n\
  <contextAttribute>\n\
  <name>temperature</name>\n\
  <type>centigrade</type>\n\
  <contextValue>" << val1;
  XML=ss.str();
  ss << "</contextValue>\n\
  </contextAttribute>\n\
  <contextAttribute>\n\
  <name>humidity</name>\n\
  <type>relative</type>\n\
  <contextValue>" << val2;
  XML=XML+ss.str();
  ss <<"</contextValue>\n\
  </contextAttribute>\n\
  <contextAttribute>\n\
  <name>occupied</name>\n\
  <type>value</type>\n\
  <contextValue>"<< val3;
  XML=XML+ss.str();
  ss <<"</contextValue>\n\
  </contextAttribute>\n\
  <contextAttribute>\n\
  <name>reserved</name>\n\
  <type>value</type>\n\
  <contextValue>" << val4;
  XML=ss.str();
  XML=XML+"</contextValue>\n\
  </contextAttribute>\n\
  </contextAttributeList>\n\
  </contextElement>\n\
  </contextElementList>\n\
  <updateAction>UPDATE</updateAction>\n\
  </updateContextRequest>\n";
  
  return XML;
}

std::string queryContext(){

	return "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n\
	<queryContextRequest>\n\
	<entityIdList>\n\
	<entityId type=\"UPCT:PARKING\" isPattern=\"false\">\n\
	<id>UPCT:PARKING:D2</id>\n\
	</entityId>\n\
	</entityIdList>\n\
	<attributeList>\n\
	<attribute>reserved</attribute>\n\
	</attributeList>\n\
	</queryContextRequest>\n";

}

void updateLed(int value){
	if(value==0){
	bcm2835_gpio_write(RED_LED, LOW);
	bcm2835_gpio_write(GREEN_LED,HIGH);
	}else{
	bcm2835_gpio_write(RED_LED, HIGH);
	bcm2835_gpio_write(GREEN_LED,LOW);
	}
}

float getTemp(void)
{
	unsigned char noError = 1;  
	value humi_val,temp_val;
	
	
	// Wait at least 11ms after power-up (chapter 3.1)
	delay(20); 
	
	// Set up the SHT1x Data and Clock Pins
	SHT1x_InitPins();
	
	// Reset the SHT1x
	SHT1x_Reset();
	
	// Request Temperature measurement
	noError = SHT1x_Measure_Start( SHT1xMeaT );
	if (!noError) {
		return 0.0;
		}
		
	// Read Temperature measurement
	noError = SHT1x_Get_Measure_Value( (unsigned short int*) &temp_val.i );
	if (!noError) {
		return 0.0;
		}

	// Request Humidity Measurement
	noError = SHT1x_Measure_Start( SHT1xMeaRh );
	if (!noError) {
		return 0.0;
		}
		
	// Read Humidity measurement
	noError = SHT1x_Get_Measure_Value( (unsigned short int*) &humi_val.i );
	if (!noError) {
		return 0.0;
		}

	// Convert intergers to float and calculate true values
	temp_val.f = (float)temp_val.i;
	humi_val.f = (float)humi_val.i;
	
	// Calculate Temperature and Humidity
	SHT1x_Calc(&humi_val.f, &temp_val.f);

	//Print the Temperature to the console
	printf("Temperature: %0.2f%cC\n",temp_val.f,0x00B0);
 	
	return temp_val.f;

}

float getHumid(void)
{
	unsigned char noError = 1;  
	value humi_val,temp_val;
	
	
	// Wait at least 11ms after power-up (chapter 3.1)
	delay(20); 
	
	// Set up the SHT1x Data and Clock Pins
	SHT1x_InitPins();
	
	// Reset the SHT1x
	SHT1x_Reset();
	
	// Request Temperature measurement
	noError = SHT1x_Measure_Start( SHT1xMeaT );
	if (!noError) {
		return 0.0;
		}
		
	// Read Temperature measurement
	noError = SHT1x_Get_Measure_Value( (unsigned short int*) &temp_val.i );
	if (!noError) {
		return 0.0;
		}

	// Request Humidity Measurement
	noError = SHT1x_Measure_Start( SHT1xMeaRh );
	if (!noError) {
		return 0.0;
		}
		
	// Read Humidity measurement
	noError = SHT1x_Get_Measure_Value( (unsigned short int*) &humi_val.i );
	if (!noError) {
		return 0.0;
		}

	// Convert intergers to float and calculate true values
	temp_val.f = (float)temp_val.i;
	humi_val.f = (float)humi_val.i;
	
	// Calculate Temperature and Humidity
	SHT1x_Calc(&humi_val.f, &temp_val.f);

	//Print the Temperature to the console
	printf("Humidity: %0.2f% %\n",humi_val.f);
 	
	return humi_val.f;

}

